//+------------------------------------------------------------------+
//|                                                 Trend ZigZag.mq4 |
//|                                          Copyright  2007, Dimi. |
//|                                   http://www.tradersforum.net.ru |
//|                                   http://www.forex-bibliothek.de |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Dimi."
#property link      "http://www.tradersforum.net.ru"
#property link      "http://www.forex-bibliothek.de" 

#property indicator_chart_window

//---- buffers
datetime daytimes[];  

//**********************************************************************************
int init()
  {
   return(0);
  }
//**********************************************************************************
int deinit()
  {
//----
ObjectsDeleteAll(0, EMPTY);   
//----
   return(0);
  }
//**********************************************************************************
int start()
  {
         string  Pa3="Trend ZigZag: M15=" +TrendByZigZag(2)+" H1=" +TrendByZigZag(4)+" H4=" +TrendByZigZag(5)+" D1=" +TrendByZigZag(6);
         ObjectCreate("TrendZigZag", OBJ_LABEL, 0, 0, 0);
         ObjectSet("TrendZigZag", OBJPROP_CORNER, 0);
         ObjectSet("TrendZigZag", OBJPROP_XDISTANCE, 350);
         ObjectSet("TrendZigZag", OBJPROP_YDISTANCE, 75);
         ObjectSetText("TrendZigZag", Pa3, 7, "Verdana",Yellow);   
   return(0);
  }
//**********************************************************************************
int TrendByZigZag(int period_counter)
  {
   int trend;
   int GrossPeriod=PeriodNumber(period_counter);
   int    counted_bars=IndicatorCounted();
   int    limit=300,bigshift;
   double zigzag1;
   if (counted_bars<0) return(-1); 
    
   if (counted_bars>0) counted_bars--; 
    
   limit=Bars-counted_bars; 
//---- 
   for (int i=0; i<limit; i++) 
   { 
   if(Time[i]>=daytimes[0]) bigshift=0; 
   else 
     { 
      bigshift = ArrayBsearch(daytimes,Time[i-1],WHOLE_ARRAY,0,MODE_DESCEND); 
      if(Period()<=GrossPeriod) bigshift++; 
     } 
      for (int cnt=bigshift; cnt<(100+bigshift); cnt++)
      {
         zigzag1=iCustom(NULL,GrossPeriod,"ZigZag",5,5,3,0,cnt+1);
         if ( zigzag1!=0 ) break;
      }
      
   if (  iClose(NULL,0,i+1)<=zigzag1 )  trend=-1;
   if (  iClose(NULL,0,i+1)>=zigzag1  )  trend=1;
   }
    return(trend);
  }
//**********************************************************************************  
int PeriodNumber(int number)
   {
   int per_min;
   switch (number)
      {
      case 2: per_min=15;break;
      case 4: per_min=60;break;
      case 5: per_min=240;break;
      case 6: per_min=1440;break;
      }
   return(per_min);   
   } 
//**********************************************************************************        